//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//=========================================================
// src/InitDevice.c: generated by Hardware Configurator
//
// This file will be regenerated when saving a document.
// leave the sections inside the "$[...]" comment tags alone
// or they will be overwritten!
//=========================================================

// USER INCLUDES
#include <SI_EFM8LB1_Register_Enums.h>
#include "InitDevice.h"

// USER PROTOTYPES
// USER FUNCTIONS

// $[Library Includes]
// [Library Includes]$

//==============================================================================
// enter_DefaultMode_from_RESET
//==============================================================================
extern void enter_DefaultMode_from_RESET(void) {
	// $[Config Calls]
	// Save the SFRPAGE
	uint8_t SFRPAGE_save = SFRPAGE;
	WDT_0_enter_DefaultMode_from_RESET();
	PORTS_0_enter_DefaultMode_from_RESET();
	PORTS_1_enter_DefaultMode_from_RESET();
	PORTS_2_enter_DefaultMode_from_RESET();
	PBCFG_0_enter_DefaultMode_from_RESET();
	ADC_0_enter_DefaultMode_from_RESET();
	VREF_0_enter_DefaultMode_from_RESET();
	RSTSRC_0_enter_DefaultMode_from_RESET();
	CLOCK_0_enter_DefaultMode_from_RESET();
	SPI_0_enter_DefaultMode_from_RESET();
	// Restore the SFRPAGE
	SFRPAGE = SFRPAGE_save;
	// [Config Calls]$

}

//================================================================================
// WDT_0_enter_DefaultMode_from_RESET
//================================================================================
extern void WDT_0_enter_DefaultMode_from_RESET(void) {
	// $[WDTCN - Watchdog Timer Control]
	// Deprecated
	// [WDTCN - Watchdog Timer Control]$

	// $[Watchdog Timer Init Variable Declarations]
	uint32_t i;
	bool ea;
	// [Watchdog Timer Init Variable Declarations]$

	// $[WDTCN_2 - Watchdog Timer Control]
	SFRPAGE = 0x00;

	// Feed WDT timer before disabling (Erratum WDT_E102)
	WDTCN = 0xA5;

	// Add 2 LFO cycle delay before disabling WDT (Erratum WDT_E102)
	for (i = 0; i < (2 * 3062500UL) / (80000 * 3); i++) {
		NOP();
	}

	// Disable WDT
	ea = IE_EA;
	IE_EA = 0;
	WDTCN = 0xDE;
	WDTCN = 0xAD;
	IE_EA = ea;

	// [WDTCN_2 - Watchdog Timer Control]$

}

//================================================================================
// PORTS_0_enter_DefaultMode_from_RESET
//================================================================================
extern void PORTS_0_enter_DefaultMode_from_RESET(void) {
	// $[P0 - Port 0 Pin Latch]
	// [P0 - Port 0 Pin Latch]$

	// $[P0MDOUT - Port 0 Output Mode]
	// [P0MDOUT - Port 0 Output Mode]$

	// $[P0MDIN - Port 0 Input Mode]
	/***********************************************************************
	 - P0.0 pin is configured for analog mode
	 - P0.1 pin is configured for analog mode
	 - P0.2 pin is configured for analog mode
	 - P0.3 pin is configured for digital mode
	 - P0.4 pin is configured for digital mode
	 - P0.5 pin is configured for digital mode
	 - P0.6 pin is configured for digital mode
	 - P0.7 pin is configured for digital mode
	 ***********************************************************************/
	P0MDIN = P0MDIN_B0__ANALOG | P0MDIN_B1__ANALOG | P0MDIN_B2__ANALOG
			| P0MDIN_B3__DIGITAL | P0MDIN_B4__DIGITAL | P0MDIN_B5__DIGITAL
			| P0MDIN_B6__DIGITAL | P0MDIN_B7__DIGITAL;
	// [P0MDIN - Port 0 Input Mode]$

	// $[P0SKIP - Port 0 Skip]
	/***********************************************************************
	 - P0.0 pin is skipped by the crossbar
	 - P0.1 pin is skipped by the crossbar
	 - P0.2 pin is skipped by the crossbar
	 - P0.3 pin is skipped by the crossbar
	 - P0.4 pin is skipped by the crossbar
	 - P0.5 pin is skipped by the crossbar
	 - P0.6 pin is skipped by the crossbar
	 - P0.7 pin is skipped by the crossbar
	 ***********************************************************************/
	P0SKIP = P0SKIP_B0__SKIPPED | P0SKIP_B1__SKIPPED | P0SKIP_B2__SKIPPED
			| P0SKIP_B3__SKIPPED | P0SKIP_B4__SKIPPED | P0SKIP_B5__SKIPPED
			| P0SKIP_B6__SKIPPED | P0SKIP_B7__SKIPPED;
	// [P0SKIP - Port 0 Skip]$

	// $[P0MASK - Port 0 Mask]
	// [P0MASK - Port 0 Mask]$

	// $[P0MAT - Port 0 Match]
	// [P0MAT - Port 0 Match]$

}

//================================================================================
// PORTS_1_enter_DefaultMode_from_RESET
//================================================================================
extern void PORTS_1_enter_DefaultMode_from_RESET(void) {
	// $[P1 - Port 1 Pin Latch]
	// [P1 - Port 1 Pin Latch]$

	// $[P1MDOUT - Port 1 Output Mode]
	/***********************************************************************
	 - P1.0 output is open-drain
	 - P1.1 output is open-drain
	 - P1.2 output is open-drain
	 - P1.3 output is push-pull
	 - P1.4 output is open-drain
	 - P1.5 output is push-pull
	 - P1.6 output is push-pull
	 ***********************************************************************/
	P1MDOUT = P1MDOUT_B0__OPEN_DRAIN | P1MDOUT_B1__OPEN_DRAIN
			| P1MDOUT_B2__OPEN_DRAIN | P1MDOUT_B3__PUSH_PULL
			| P1MDOUT_B4__OPEN_DRAIN | P1MDOUT_B5__PUSH_PULL
			| P1MDOUT_B6__PUSH_PULL;
	// [P1MDOUT - Port 1 Output Mode]$

	// $[P1MDIN - Port 1 Input Mode]
	// [P1MDIN - Port 1 Input Mode]$

	// $[P1SKIP - Port 1 Skip]
	/***********************************************************************
	 - P1.0 pin is skipped by the crossbar
	 - P1.1 pin is skipped by the crossbar
	 - P1.2 pin is skipped by the crossbar
	 - P1.3 pin is not skipped by the crossbar
	 - P1.4 pin is not skipped by the crossbar
	 - P1.5 pin is not skipped by the crossbar
	 - P1.6 pin is not skipped by the crossbar
	 ***********************************************************************/
	P1SKIP = P1SKIP_B0__SKIPPED | P1SKIP_B1__SKIPPED | P1SKIP_B2__SKIPPED
			| P1SKIP_B3__NOT_SKIPPED | P1SKIP_B4__NOT_SKIPPED
			| P1SKIP_B5__NOT_SKIPPED | P1SKIP_B6__NOT_SKIPPED;
	// [P1SKIP - Port 1 Skip]$

	// $[P1MASK - Port 1 Mask]
	// [P1MASK - Port 1 Mask]$

	// $[P1MAT - Port 1 Match]
	// [P1MAT - Port 1 Match]$

}

//================================================================================
// PORTS_2_enter_DefaultMode_from_RESET
//================================================================================
extern void PORTS_2_enter_DefaultMode_from_RESET(void) {
	// $[P2 - Port 2 Pin Latch]
	// [P2 - Port 2 Pin Latch]$

	// $[P2MDOUT - Port 2 Output Mode]
	/***********************************************************************
	 - P2.0 output is push-pull
	 - P2.1 output is push-pull
	 - P2.2 output is open-drain
	 - P2.3 output is open-drain
	 ***********************************************************************/
	P2MDOUT = P2MDOUT_B0__PUSH_PULL | P2MDOUT_B1__PUSH_PULL
			| P2MDOUT_B2__OPEN_DRAIN | P2MDOUT_B3__OPEN_DRAIN;
	// [P2MDOUT - Port 2 Output Mode]$

	// $[P2MDIN - Port 2 Input Mode]
	// [P2MDIN - Port 2 Input Mode]$

	// $[P2SKIP - Port 2 Skip]
	// [P2SKIP - Port 2 Skip]$

	// $[P2MASK - Port 2 Mask]
	// [P2MASK - Port 2 Mask]$

	// $[P2MAT - Port 2 Match]
	// [P2MAT - Port 2 Match]$

}

//================================================================================
// PORTS_3_enter_DefaultMode_from_RESET
//================================================================================
extern void PORTS_3_enter_DefaultMode_from_RESET(void) {
	// $[P3 - Port 3 Pin Latch]
	// [P3 - Port 3 Pin Latch]$

	// $[P3MDOUT - Port 3 Output Mode]
	/*
	 // B0 (Port 3 Bit 0 Output Mode) = OPEN_DRAIN (P3.0 output is open-
	 //     drain.)
	 // B1 (Port 3 Bit 1 Output Mode) = OPEN_DRAIN (P3.1 output is open-
	 //     drain.)
	 // B2 (Port 3 Bit 2 Output Mode) = OPEN_DRAIN (P3.2 output is open-
	 //     drain.)
	 // B3 (Port 3 Bit 3 Output Mode) = OPEN_DRAIN (P3.3 output is open-
	 //     drain.)
	 // B4 (Port 3 Bit 4 Output Mode) = PUSH_PULL (P3.4 output is push-pull.)
	 // B7 (Port 3 Bit 7 Output Mode) = OPEN_DRAIN (P3.7 output is open-
	 //     drain.)
	 */
	SFRPAGE = 0x20;
	P3MDOUT = P3MDOUT_B0__OPEN_DRAIN | P3MDOUT_B1__OPEN_DRAIN
			| P3MDOUT_B2__OPEN_DRAIN | P3MDOUT_B3__OPEN_DRAIN
			| P3MDOUT_B4__PUSH_PULL | P3MDOUT_B7__OPEN_DRAIN;
	// [P3MDOUT - Port 3 Output Mode]$

	// $[P3MDIN - Port 3 Input Mode]
	// [P3MDIN - Port 3 Input Mode]$

}

//================================================================================
// PBCFG_0_enter_DefaultMode_from_RESET
//================================================================================
extern void PBCFG_0_enter_DefaultMode_from_RESET(void) {
	// $[XBR2 - Port I/O Crossbar 2]
	/***********************************************************************
	 - Weak Pullups enabled 
	 - Crossbar enabled
	 - UART1 I/O unavailable at Port pin
	 - UART1 RTS1 unavailable at Port pin
	 - UART1 CTS1 unavailable at Port pin
	 ***********************************************************************/
	XBR2 = XBR2_WEAKPUD__PULL_UPS_ENABLED | XBR2_XBARE__ENABLED
			| XBR2_URT1E__DISABLED | XBR2_URT1RTSE__DISABLED
			| XBR2_URT1CTSE__DISABLED;
	// [XBR2 - Port I/O Crossbar 2]$

	// $[PRTDRV - Port Drive Strength]
	// [PRTDRV - Port Drive Strength]$

	// $[XBR0 - Port I/O Crossbar 0]
	/***********************************************************************
	 - UART0 I/O unavailable at Port pin
	 - SPI I/O routed to Port pins
	 - SMBus 0 I/O unavailable at Port pins
	 - CP0 unavailable at Port pin
	 - Asynchronous CP0 unavailable at Port pin
	 - CP1 unavailable at Port pin
	 - Asynchronous CP1 unavailable at Port pin
	 - SYSCLK unavailable at Port pin
	 ***********************************************************************/
	XBR0 = XBR0_URT0E__DISABLED | XBR0_SPI0E__ENABLED | XBR0_SMB0E__DISABLED
			| XBR0_CP0E__DISABLED | XBR0_CP0AE__DISABLED | XBR0_CP1E__DISABLED
			| XBR0_CP1AE__DISABLED | XBR0_SYSCKE__DISABLED;
	// [XBR0 - Port I/O Crossbar 0]$

	// $[XBR1 - Port I/O Crossbar 1]
	// [XBR1 - Port I/O Crossbar 1]$

}

//================================================================================
// ADC_0_enter_DefaultMode_from_RESET
//================================================================================
extern void ADC_0_enter_DefaultMode_from_RESET(void) {
	// $[ADC0CN2 - ADC0 Control 2]
	// [ADC0CN2 - ADC0 Control 2]$

	// $[ADC0CN1 - ADC0 Control 1]
	/***********************************************************************
	 - ADC0 operates in 14-bit mode
	 - Right justified. No shifting applied
	 - Perform and Accumulate 1 conversion
	 ***********************************************************************/
	ADC0CN1 = ADC0CN1_ADBITS__14_BIT | ADC0CN1_ADSJST__RIGHT_NO_SHIFT
			| ADC0CN1_ADRPT__ACC_1;
	// [ADC0CN1 - ADC0 Control 1]$

	// $[ADC0MX - ADC0 Multiplexer Selection]
	/***********************************************************************
	 - Select ADC0.1
	 ***********************************************************************/
	ADC0MX = ADC0MX_ADC0MX__ADC0P1;
	// [ADC0MX - ADC0 Multiplexer Selection]$

	// $[ADC0CF2 - ADC0 Power Control]
	/***********************************************************************
	 - The ADC0 ground reference is the AGND pin
	 - The ADC0 voltage reference is the VREF pin 
	 - Power Up Delay Time = 0x1F
	 ***********************************************************************/
	ADC0CF2 = ADC0CF2_GNDSL__AGND_PIN | ADC0CF2_REFSL__VREF_PIN
			| (0x1F << ADC0CF2_ADPWR__SHIFT);
	// [ADC0CF2 - ADC0 Power Control]$

	// $[ADC0CF0 - ADC0 Configuration]
	/***********************************************************************
	 - ADCCLK = SYSCLK
	 - SAR Clock Divider = 0x00
	 ***********************************************************************/
	ADC0CF0 = ADC0CF0_ADCLKSEL__SYSCLK | (0x00 << ADC0CF0_ADSC__SHIFT);
	// [ADC0CF0 - ADC0 Configuration]$

	// $[ADC0CF1 - ADC0 Configuration]
	/***********************************************************************
	 - Disable low power mode
	 - Conversion Tracking Time = 0x04
	 ***********************************************************************/
	ADC0CF1 = ADC0CF1_ADLPM__LP_DISABLED | (0x04 << ADC0CF1_ADTK__SHIFT);
	// [ADC0CF1 - ADC0 Configuration]$

	// $[ADC0ASAL - ADC0 Autoscan Start Address Low Byte]
	// [ADC0ASAL - ADC0 Autoscan Start Address Low Byte]$

	// $[ADC0GTH - ADC0 Greater-Than High Byte]
	// [ADC0GTH - ADC0 Greater-Than High Byte]$

	// $[ADC0GTL - ADC0 Greater-Than Low Byte]
	// [ADC0GTL - ADC0 Greater-Than Low Byte]$

	// $[ADC0LTH - ADC0 Less-Than High Byte]
	// [ADC0LTH - ADC0 Less-Than High Byte]$

	// $[ADC0LTL - ADC0 Less-Than Low Byte]
	// [ADC0LTL - ADC0 Less-Than Low Byte]$

	// $[ADC0ASCF - ADC0 Autoscan Configuration]
	/***********************************************************************
	 - The selected conversion trigger source will begin each scan cycle
	 ***********************************************************************/
	SFRPAGE = 0x30;
	ADC0ASCF |= ADC0ASCF_STEN__SINGLE_TRIGGER;
	// [ADC0ASCF - ADC0 Autoscan Configuration]$

	// $[ADC0CN0 - ADC0 Control 0]
	/***********************************************************************
	 - Enable ADC0 
	 ***********************************************************************/
	SFRPAGE = 0x00;
	ADC0CN0 |= ADC0CN0_ADEN__ENABLED;
	// [ADC0CN0 - ADC0 Control 0]$

}

//================================================================================
// CLOCK_0_enter_DefaultMode_from_RESET
//================================================================================
extern void CLOCK_0_enter_DefaultMode_from_RESET(void) {
	// $[HFOSC1 Setup]
	// Ensure SYSCLK is > 24 MHz before switching to HFOSC1
	CLKSEL = CLKSEL_CLKSL__HFOSC0 | CLKSEL_CLKDIV__SYSCLK_DIV_1;
	while ((CLKSEL & CLKSEL_DIVRDY__BMASK) == CLKSEL_DIVRDY__NOT_READY)
		;
	// [HFOSC1 Setup]$

	// $[CLKSEL - Clock Select]
	/***********************************************************************
	 - Clock derived from the Internal High Frequency Oscillator 1
	 - SYSCLK is equal to selected clock source divided by 4
	 ***********************************************************************/
	CLKSEL = CLKSEL_CLKSL__HFOSC1 | CLKSEL_CLKDIV__SYSCLK_DIV_4;
	while ((CLKSEL & CLKSEL_DIVRDY__BMASK) == CLKSEL_DIVRDY__NOT_READY)
		;
	// [CLKSEL - Clock Select]$

}

//================================================================================
// TIMER01_0_enter_DefaultMode_from_RESET
//================================================================================
///extern void TIMER01_0_enter_DefaultMode_from_RESET(void) {
// $[Timer Initialization]
//Save Timer Configuration
///uint8_t TCON_save;
///TCON_save = TCON;
//Stop Timers
///TCON &= ~TCON_TR0__BMASK & ~TCON_TR1__BMASK;

// [Timer Initialization]$

// $[TH0 - Timer 0 High Byte]
// [TH0 - Timer 0 High Byte]$

// $[TL0 - Timer 0 Low Byte]
// [TL0 - Timer 0 Low Byte]$

// $[TH1 - Timer 1 High Byte]
/***********************************************************************
 - Timer 1 High Byte = 0xE6
 ***********************************************************************/
///TH1 = (0xE6 << TH1_TH1__SHIFT);
// [TH1 - Timer 1 High Byte]$
// $[TL1 - Timer 1 Low Byte]
// [TL1 - Timer 1 Low Byte]$
// $[Timer Restoration]
//Restore Timer Configuration
///TCON |= (TCON_save & TCON_TR0__BMASK) | (TCON_save & TCON_TR1__BMASK);
// [Timer Restoration]$
///}
//================================================================================
// TIMER16_2_enter_DefaultMode_from_RESET
//================================================================================
///extern void TIMER16_2_enter_DefaultMode_from_RESET(void) {
// $[Timer Initialization]
// Save Timer Configuration
///uint8_t TMR2CN0_TR2_save;
///TMR2CN0_TR2_save = TMR2CN0 & TMR2CN0_TR2__BMASK;
// Stop Timer
///TMR2CN0 &= ~(TMR2CN0_TR2__BMASK);
// [Timer Initialization]$
// $[TMR2CN1 - Timer 2 Control 1]
// [TMR2CN1 - Timer 2 Control 1]$
// $[TMR2CN0 - Timer 2 Control]
// [TMR2CN0 - Timer 2 Control]$
// $[TMR2H - Timer 2 High Byte]
/***********************************************************************
 - Timer 2 High Byte = 0xF3
 ***********************************************************************/
///TMR2H = (0xF3 << TMR2H_TMR2H__SHIFT);
// [TMR2H - Timer 2 High Byte]$
// $[TMR2L - Timer 2 Low Byte]
/***********************************************************************
 - Timer 2 Low Byte = 0x8A
 ***********************************************************************/
///TMR2L = (0x8A << TMR2L_TMR2L__SHIFT);
// [TMR2L - Timer 2 Low Byte]$
// $[TMR2RLH - Timer 2 Reload High Byte]
/***********************************************************************
 - Timer 2 Reload High Byte = 0xE8
 ***********************************************************************/
///TMR2RLH = (0xE8 << TMR2RLH_TMR2RLH__SHIFT);
// [TMR2RLH - Timer 2 Reload High Byte]$
// $[TMR2RLL - Timer 2 Reload Low Byte]
/***********************************************************************
 - Timer 2 Reload Low Byte = 0x90
 ***********************************************************************/
///TMR2RLL = (0x90 << TMR2RLL_TMR2RLL__SHIFT);
// [TMR2RLL - Timer 2 Reload Low Byte]$
// $[TMR2CN0]
// [TMR2CN0]$
// $[Timer Restoration]
// Restore Timer Configuration
///TMR2CN0 |= TMR2CN0_TR2_save;
// [Timer Restoration]$
///}
//================================================================================
// TIMER_SETUP_0_enter_DefaultMode_from_RESET
//================================================================================
///extern void TIMER_SETUP_0_enter_DefaultMode_from_RESET(void) {
// $[CKCON0 - Clock Control 0]
/***********************************************************************
 - System clock divided by 12
 - Counter/Timer 0 uses the clock defined by the prescale field, SCA
 - Timer 2 high byte uses the clock defined by T2XCLK in TMR2CN0
 - Timer 2 low byte uses the system clock
 - Timer 3 high byte uses the clock defined by T3XCLK in TMR3CN0
 - Timer 3 low byte uses the system clock
 - Timer 1 uses the clock defined by the prescale field, SCA
 ***********************************************************************/
///SFRPAGE = 0x00;
///CKCON0 = CKCON0_SCA__SYSCLK_DIV_12 | CKCON0_T0M__PRESCALE
///		| CKCON0_T2MH__EXTERNAL_CLOCK | CKCON0_T2ML__SYSCLK
///		| CKCON0_T3MH__EXTERNAL_CLOCK | CKCON0_T3ML__SYSCLK
///		| CKCON0_T1M__PRESCALE;
// [CKCON0 - Clock Control 0]$
// $[CKCON1 - Clock Control 1]
/***********************************************************************
 - Timer 4 high byte uses the clock defined by T4XCLK in TMR4CN0
 - Timer 4 low byte uses the clock defined by T4XCLK in TMR4CN0
 - Timer 5 high byte uses the clock defined by T5XCLK in TMR5CN0
 - Timer 5 low byte uses the system clock
 ***********************************************************************/
///SFRPAGE = 0x10;
///CKCON1 = CKCON1_T4MH__EXTERNAL_CLOCK | CKCON1_T4ML__EXTERNAL_CLOCK
///		| CKCON1_T5MH__EXTERNAL_CLOCK | CKCON1_T5ML__SYSCLK;
// [CKCON1 - Clock Control 1]$
// $[TMOD - Timer 0/1 Mode]
/***********************************************************************
 - Mode 0, 13-bit Counter/Timer
 - Mode 2, 8-bit Counter/Timer with Auto-Reload
 - Timer Mode
 - Timer 0 enabled when TR0 = 1 irrespective of INT0 logic level
 - Timer Mode
 - Timer 1 enabled when TR1 = 1 irrespective of INT1 logic level
 ***********************************************************************/
///SFRPAGE = 0x00;
///TMOD = TMOD_T0M__MODE0 | TMOD_T1M__MODE2 | TMOD_CT0__TIMER
///		| TMOD_GATE0__DISABLED | TMOD_CT1__TIMER | TMOD_GATE1__DISABLED;
// [TMOD - Timer 0/1 Mode]$
// $[TCON - Timer 0/1 Control]
// [TCON - Timer 0/1 Control]$
///}
//================================================================================
// UART_0_enter_DefaultMode_from_RESET
//================================================================================
///extern void UART_0_enter_DefaultMode_from_RESET(void) {
// $[SCON0 - UART0 Serial Port Control]
// [SCON0 - UART0 Serial Port Control]$
///}
//================================================================================
// INTERRUPT_0_enter_DefaultMode_from_RESET
//================================================================================
///extern void INTERRUPT_0_enter_DefaultMode_from_RESET(void) {
// $[EIE1 - Extended Interrupt Enable 1]
/***********************************************************************
 - Enable interrupt requests generated by the ADINT flag
 - Disable ADC0 Window Comparison interrupt
 - Disable CP0 interrupts
 - Disable CP1 interrupts
 - Disable all Port Match interrupts
 - Disable all PCA0 interrupts
 - Disable all SMB0 interrupts
 - Disable Timer 3 interrupts
 ***********************************************************************/
///EIE1 = EIE1_EADC0__ENABLED | EIE1_EWADC0__DISABLED | EIE1_ECP0__DISABLED
///		| EIE1_ECP1__DISABLED | EIE1_EMAT__DISABLED | EIE1_EPCA0__DISABLED
///		| EIE1_ESMB0__DISABLED | EIE1_ET3__DISABLED;
// [EIE1 - Extended Interrupt Enable 1]$
// $[EIE2 - Extended Interrupt Enable 2]
// [EIE2 - Extended Interrupt Enable 2]$
// $[EIP1H - Extended Interrupt Priority 1 High]
// [EIP1H - Extended Interrupt Priority 1 High]$
// $[EIP1 - Extended Interrupt Priority 1 Low]
// [EIP1 - Extended Interrupt Priority 1 Low]$
// $[EIP2 - Extended Interrupt Priority 2]
// [EIP2 - Extended Interrupt Priority 2]$
// $[EIP2H - Extended Interrupt Priority 2 High]
// [EIP2H - Extended Interrupt Priority 2 High]$
// $[IE - Interrupt Enable]
/***********************************************************************
 - Enable each interrupt according to its individual mask setting
 - Disable external interrupt 0
 - Disable external interrupt 1
 - Disable all SPI0 interrupts
 - Disable all Timer 0 interrupt
 - Disable all Timer 1 interrupt
 - Disable Timer 2 interrupt
 - Disable UART0 interrupt
 ***********************************************************************/
///IE = IE_EA__ENABLED | IE_EX0__DISABLED | IE_EX1__DISABLED
///		| IE_ESPI0__DISABLED | IE_ET0__DISABLED | IE_ET1__DISABLED
///		| IE_ET2__DISABLED | IE_ES0__DISABLED;
// [IE - Interrupt Enable]$
// $[IP - Interrupt Priority]
// [IP - Interrupt Priority]$
// $[IPH - Interrupt Priority High]
// [IPH - Interrupt Priority High]$
///}
///extern void CLU_0_enter_DefaultMode_from_RESET(void) {
///}
///extern void CL_0_enter_DefaultMode_from_RESET(void) {
///}
extern void EXTOSC_0_enter_DefaultMode_from_RESET(void) {
	// $[Delay counter definition]
	// [Delay counter definition]$

	// $[XOSC0CN - External Oscillator Control]
	/***********************************************************************
	 - External CMOS Clock Mode
	 ***********************************************************************/
	XOSC0CN &= ~XOSC0CN_XOSCMD__FMASK;
	XOSC0CN |= XOSC0CN_XOSCMD__CMOS;
	// [XOSC0CN - External Oscillator Control]$

}

extern void CIP51_0_enter_DefaultMode_from_RESET(void) {
	// $[PFE0CN - Prefetch Engine Control]
	/***********************************************************************
	 - SYSCLK < 75 MHz
	 ***********************************************************************/
	PFE0CN = PFE0CN_FLRT__SYSCLK_BELOW_75_MHZ;
	// [PFE0CN - Prefetch Engine Control]$

}

///extern void TIMER16_3_enter_DefaultMode_from_RESET(void) {
// $[Timer Initialization]
// Save Timer Configuration
///uint8_t TMR3CN0_TR3_save;
///TMR3CN0_TR3_save = TMR3CN0 & TMR3CN0_TR3__BMASK;
// Stop Timer
///TMR3CN0 &= ~(TMR3CN0_TR3__BMASK);
// [Timer Initialization]$

// $[TMR3CN1 - Timer 3 Control 1]
/***********************************************************************
 - Capture high-to-low transitions on the T2 input pin
 - Timer will only reload on overflow events
 - Suspend Timer Synchronization Status = 0x00
 ***********************************************************************/
///SFRPAGE = 0x10;
///TMR3CN1 = TMR3CN1_T3CSEL__PIN | TMR3CN1_RLFSEL__NONE
///		| (0x00 << TMR3CN1_STSYNC__SHIFT);
// [TMR3CN1 - Timer 3 Control 1]$
// $[TMR3CN0 - Timer 3 Control]
// [TMR3CN0 - Timer 3 Control]$
// $[TMR3H - Timer 3 High Byte]
// [TMR3H - Timer 3 High Byte]$
// $[TMR3L - Timer 3 Low Byte]
/***********************************************************************
 - Timer 3 Low Byte = 0xC8
 ***********************************************************************/
///SFRPAGE = 0x00;
///TMR3L = (0xC8 << TMR3L_TMR3L__SHIFT);
// [TMR3L - Timer 3 Low Byte]$
// $[TMR3RLH - Timer 3 Reload High Byte]
/***********************************************************************
 - Timer 3 Reload High Byte = 0x73
 ***********************************************************************/
///TMR3RLH = (0x73 << TMR3RLH_TMR3RLH__SHIFT);
// [TMR3RLH - Timer 3 Reload High Byte]$
// $[TMR3RLL - Timer 3 Reload Low Byte]
/***********************************************************************
 - Timer 3 Reload Low Byte = 0x60
 ***********************************************************************/
///TMR3RLL = (0x60 << TMR3RLL_TMR3RLL__SHIFT);
// [TMR3RLL - Timer 3 Reload Low Byte]$
// $[TMR3CN0]
// [TMR3CN0]$
// $[Timer Restoration]
// Restore Timer Configuration
///TMR3CN0 |= TMR3CN0_TR3_save;
// [Timer Restoration]$
///}
///extern void TIMER16_4_enter_DefaultMode_from_RESET(void) {
// $[Timer Initialization]
// Save Timer Configuration
///	uint8_t TMR4CN0_TR4_save;
///	SFRPAGE = 0x10;
///	TMR4CN0_TR4_save = TMR4CN0 & TMR4CN0_TR4__BMASK;
// Stop Timer
///	TMR4CN0 &= ~(TMR4CN0_TR4__BMASK);
// [Timer Initialization]$
// $[TMR4CN1 - Timer 4 Control 1]
/***********************************************************************
 - Capture high-to-low transitions on the T2 input pin
 - Timer will only reload on overflow events
 - Suspend Timer Synchronization Status = 0x00
 ***********************************************************************/
///	TMR4CN1 = TMR4CN1_T4CSEL__PIN | TMR4CN1_RLFSEL__NONE
///			| (0x00 << TMR4CN1_STSYNC__SHIFT);
// [TMR4CN1 - Timer 4 Control 1]$
// $[TMR4CN0 - Timer 4 Control]
/***********************************************************************
 - Timer 4 is clocked by Timer 3 overflows
 ***********************************************************************/
///	TMR4CN0 &= ~TMR4CN0_T4XCLK__FMASK;
///	TMR4CN0 |= TMR4CN0_T4XCLK__TIMER3;
// [TMR4CN0 - Timer 4 Control]$
// $[TMR4H - Timer 4 High Byte]
// [TMR4H - Timer 4 High Byte]$
// $[TMR4L - Timer 4 Low Byte]
// [TMR4L - Timer 4 Low Byte]$
// $[TMR4RLH - Timer 4 Reload High Byte]
/***********************************************************************
 - Timer 4 Reload High Byte = 0xFF
 ***********************************************************************/
///	TMR4RLH = (0xFF << TMR4RLH_TMR4RLH__SHIFT);
// [TMR4RLH - Timer 4 Reload High Byte]$
// $[TMR4RLL - Timer 4 Reload Low Byte]
/***********************************************************************
 - Timer 4 Reload Low Byte = 0x9C
 ***********************************************************************/
///	TMR4RLL = (0x9C << TMR4RLL_TMR4RLL__SHIFT);
// [TMR4RLL - Timer 4 Reload Low Byte]$
// $[TMR4CN0]
// [TMR4CN0]$
// $[Timer Restoration]
// Restore Timer Configuration
///	TMR4CN0 |= TMR4CN0_TR4_save;
// [Timer Restoration]$
///}
extern void SPI_0_enter_DefaultMode_from_RESET(void) {
	// $[SPI0CKR - SPI0 Clock Rate]
	/***********************************************************************
	 - SPI0 Clock Rate = 0x02
	 ***********************************************************************/
	SPI0CKR = (0x02 << SPI0CKR_SPI0CKR__SHIFT);
	// [SPI0CKR - SPI0 Clock Rate]$
	// fsck = SYSCLK / (2 * (SPI0CKR + 1))=50 M/4=12.5   SPI0CKR=1
	//                                    =50 /2=25   SPI0CKR=0
	// $[SPI0FCN0 - SPI0 FIFO Control 0]
	// [SPI0FCN0 - SPI0 FIFO Control 0]$

	// $[SPI0FCN1 - SPI0 FIFO Control 1]
	/***********************************************************************
	 - SPI0 interrupts will not be generated when SPIF is set
	 ***********************************************************************/
	SFRPAGE = 0x20;
	SPI0FCN1 &= ~SPI0FCN1_SPIFEN__BMASK;
	// [SPI0FCN1 - SPI0 FIFO Control 1]$

//############################################
//	SFRPAGE = 0x20;
//	SPI0FCN1 &= ~SPI0FCN1_SPIFEN__BMASK;// FIFO ENABLE
//  SPI0FCN1 &= ~(SPI0FCN1_RXFIFOE__BMASK | SPI0FCN1_SPIFEN__BMASK);//FIFO DISABLE

//	SFRPAGE = 0x00;
//#############################################

	// $[SPI0CFG - SPI0 Configuration]
	/***********************************************************************
	 - Enable master mode. Operate as a master
	 ***********************************************************************/
	SFRPAGE = 0x00;
	SPI0CFG |= SPI0CFG_MSTEN__MASTER_ENABLED;
	// [SPI0CFG - SPI0 Configuration]$

	// $[SPI0PCF - SPI0 Pin Configuration]
	// [SPI0PCF - SPI0 Pin Configuration]$

	// $[SPI0CN0 - SPI0 Control]
	/***********************************************************************
	 - Enable the SPI module
	 - 3-Wire Slave or 3-Wire Master Mode
	 ***********************************************************************/
	SPI0CN0 &= ~SPI0CN0_NSSMD__FMASK;
	SPI0CN0 |= SPI0CN0_SPIEN__ENABLED;
	// [SPI0CN0 - SPI0 Control]$

	//SPI0CFG = 0x40;  //master, ckpol = ckpha = 0.
	//SPI0CN0 = 0x01;  //0x01-3wire single master, SPI ENABLE.
//##################################################3

}

extern void VREF_0_enter_DefaultMode_from_RESET(void) {
	// $[REF0CN - Voltage Reference Control]
	// [REF0CN - Voltage Reference Control]$

}

///extern void TIMER16_5_enter_DefaultMode_from_RESET(void) {
// $[Timer Initialization]
// Save Timer Configuration
uint8_t TMR5CN0_TR5_save;
///	TMR5CN0_TR5_save = TMR5CN0 & TMR5CN0_TR5__BMASK;
// Stop Timer
///	TMR5CN0 &= ~(TMR5CN0_TR5__BMASK);
// [Timer Initialization]$

// $[TMR5CN1 - Timer 5 Control 1]
// [TMR5CN1 - Timer 5 Control 1]$

// $[TMR5CN0 - Timer 5 Control]
// [TMR5CN0 - Timer 5 Control]$

// $[TMR5H - Timer 5 High Byte]
// [TMR5H - Timer 5 High Byte]$

// $[TMR5L - Timer 5 Low Byte]
// [TMR5L - Timer 5 Low Byte]$

// $[TMR5RLH - Timer 5 Reload High Byte]
/***********************************************************************
 - Timer 5 Reload High Byte = 0xE6
 ***********************************************************************/
///	TMR5RLH = (0xE6 << TMR5RLH_TMR5RLH__SHIFT);
// [TMR5RLH - Timer 5 Reload High Byte]$
// $[TMR5RLL - Timer 5 Reload Low Byte]
/***********************************************************************
 - Timer 5 Reload Low Byte = 0x6F
 ***********************************************************************/
///	TMR5RLL = (0x6F << TMR5RLL_TMR5RLL__SHIFT);
// [TMR5RLL - Timer 5 Reload Low Byte]$
// $[TMR5CN0]
/***********************************************************************
 - Start Timer 5 running
 ***********************************************************************/
///	TMR5CN0 |= TMR5CN0_TR5__RUN;
// [TMR5CN0]$
// $[Timer Restoration]
// Restore Timer Configuration
///	TMR5CN0 |= TMR5CN0_TR5_save;
// [Timer Restoration]$
///}
extern void RSTSRC_0_enter_DefaultMode_from_RESET(void) {
	// $[RSTSRC - Reset Source]
	/***********************************************************************
	 - A power-on or supply monitor reset occurred
	 - A missing clock detector reset occurred
	 - A Comparator 0 reset did not occur
	 ***********************************************************************/
	RSTSRC = RSTSRC_PORSF__SET | RSTSRC_MCDRSF__SET | RSTSRC_C0RSEF__NOT_SET;
	// [RSTSRC - Reset Source]$

}

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
extern void HFOSC_0_enter_DefaultMode_from_RESET(void) {

}

